function autodock_get_best_cluster_pdb_from_dlg(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function: autodock_get_best_cluster_pdb_from_dlg
% Description: Extract all docked conformations belonging to 
%               the best cluster.
% Input file: filename.dlg and filename.dlg.pdb
% Output file: filename_best_cluster.pdb
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin~=1
    disp('Usage: autodock_get_best_cluster_pdb_from_dlg(filename)');
    return;
end
count=0;
dlg_file=sprintf('%s.dlg',filename);
dlg_pdb_file=sprintf('%s.dlg.pdb',filename);

fid=fopen(dlg_file);
while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>10)
        a=findstr(tline,'RMSD TABLE');
        if (length(a)>0)
            for i=1:8
                tline=fgetl(fid);
            end
            [a,b]=strtok(tline);
            a=sscanf(a,'%d');
            while (a==1)
                count=count+1;
                [b,c]=strtok(b);
                [b,c]=strtok(c);
                wanted(count)=sscanf(b,'%d');
                tline=fgetl(fid);
                [a,b]=strtok(tline);
                a=sscanf(a,'%d');
            end
            if (a~=1)
                break;
            end
        end
    end
end

fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read from dlg.pdb file and output dockings belonging to the best cluster to a single pdb file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(dlg_pdb_file);
filename=sprintf('%s_best_cluster.pdb',filename);
fid1=fopen(filename,'wt');

while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>5)
        if (strcmp(tline(1:5),'MODEL')==1)
            [a,b]=strtok(tline);
            model=sscanf(b,'%d');
            a=find(wanted==model);
            if (length(a)>0)
                while ~feof(fid)
                    tline=fgetl(fid);
                    if (length(tline)>5)
                        if (strcmp(tline(1:4),'ATOM')==1)
                            fprintf(fid1,'%s\n',tline);
                        elseif (strcmp(tline(1:6),'ENDMDL')==1)
                            fprintf(fid1,'%s\n',tline);
                            break;
                        end
                    end
                end
            end
        end
    end
end
fclose(fid);
fclose(fid1);

disp('Generated output file:');
filename