function [outline]=autodock_get_min_energy_from_dlg(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function: autodock_get_min_energy_from_dlg
% Description: Extract the docked conformation which has the lowest
%               docked energy
% Input file: filename.dlg and filename.dlg.pdb
% Output file: filename_min_energy.pdb
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin~=1
    disp('Usage: [outline]=autodock_get_min_energy_from_dlg(filename)');
    return;
end

dlg_file=sprintf('%s.dlg',filename);
dlg_pdb_file=sprintf('%s.dlg.pdb',filename);

fid=fopen(dlg_file);
count=0;
while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>10)
        a=findstr(tline,'CLUSTERING HISTOGRAM');
        if (length(a)>0)
            for i=1:9
                tline=fgetl(fid);
            end
            b=tline;
            for i=1:5
                [a,b]=strtok(b);
            end
            model_selected=sscanf(a,'%d');
            break;
        end
    end
end

fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read from dlg.pdb file and output dockings belonging to the best cluster to a single pdb file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(dlg_pdb_file);
filename=sprintf('%s_min_energy.pdb',filename);
disp('Output file:')
filename
fid1=fopen(filename,'wt');

while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>5)
        if (strcmp(tline(1:5),'MODEL')==1)
            [a,b]=strtok(tline);
            model=sscanf(b,'%d');
            if (model==model_selected)
                fprintf(fid1,'%s\n',tline);
                while ~feof(fid)'
                    tline=fgetl(fid);
                    if (length(tline)>5)
                        if (strcmp(tline(1:6),'ENDMDL')==1)
                            fprintf(fid1,'%s\n',tline);
                            fclose(fid1);
                            fclose(fid);
                            return;
                        else
                            fprintf(fid1,'%s\n',tline);
                        end
                    end
                end
            end
        end
    end
end

