function [outline]=autodock_get_min_rmsd_from_dlg(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function: autodock_get_min_rmsd_from_dlg
% Description: Extract the docked conformation that is lowest in rmsd from
%               the starting position
% Files needed: filename.dlg and filename.dlg.pdb
% Output filename: filename_min_ref_rmsd.pdb
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin~=1
    disp('Usage: [outline]=autodock_get_min_rmsd_from_dlg(filename)');
    return;
end

dlg_file=sprintf('%s.dlg',filename);
dlg_pdb_file=sprintf('%s.dlg.pdb',filename);

fid=fopen(dlg_file);
count=0;
while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>10)
        a=findstr(tline,'RMSD TABLE');
        if (length(a)>0)
            for i=1:8
                tline=fgetl(fid);
            end
            a=findstr(tline,'________');
            while (length(a)==0)
                count=count+1;
                line(count)=cellstr(tline);
                [b,c]=strtok(tline);
                cluster_id(count)=sscanf(b,'%d');
                [b,c]=strtok(c);
                [b,c]=strtok(c);     
                model(count)=sscanf(b,'%d');
                [b,c]=strtok(c);
                docked_energy(count)=sscanf(b,'%f');
                [b,c]=strtok(c);
                [b,c]=strtok(c);                
                ref_rmsd(count)=sscanf(b,'%f');
                tline=fgetl(fid);
                a=findstr(tline,'________');
            end
            if (length(a)>0)
                break;
            end
        end
    end
end

fclose(fid);

[a,b]=min(ref_rmsd);
model_selected=model(b);
outline=line(b);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read from dlg.pdb file and output dockings belonging to the best cluster to a single pdb file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(dlg_pdb_file);
filename=sprintf('%s_min_ref_rmsd.pdb',filename);
disp('Output filename:')
filename
fid1=fopen(filename,'wt');

while ~feof(fid)
    tline=fgetl(fid);
    if (length(tline)>5)
        if (strcmp(tline(1:5),'MODEL')==1)
            [a,b]=strtok(tline);
            model=sscanf(b,'%d');
            if (model==model_selected)
                fprintf(fid1,'%s\n',tline);
                while ~feof(fid)'
                    tline=fgetl(fid);
                    if (length(tline)>5)
                        if (strcmp(tline(1:6),'ENDMDL')==1)
                            fprintf(fid1,'%s\n',tline);
                            fclose(fid1);
                            fclose(fid);
                            return;
                        else
                            fprintf(fid1,'%s\n',tline);
                        end
                    end
                end
            end
        end
    end
end


